// Double squarawave music with PWM played on the STAF.
// main.c
// The main C file.
// 
// 29.11.2016
// Copyright (C) 2014-2016  Balthasar Szczepański
// 
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.
	
	// #define OLD_HARDWARE
	#include "msp430.h"
	#include "definitions.h"
	#include "sheet.h"
	
	unsigned char inbuf[8];
	unsigned char outbuf[8] __attribute__ ((aligned (2))); 
	
	unsigned char channel; 
	unsigned char active=0;
	unsigned char select=0x33;
	
	unsigned short wavestop1=0;
	unsigned short wavestop2=0;
	unsigned short wavecount1=0;
	unsigned short wavecount2=0;
	
	unsigned short noteend1=0;
	unsigned short noteend2=0;
	unsigned short notestop1=0;
	unsigned short notestop2=0;
	unsigned short notecount1=0xf000;
	unsigned short notecount2=0xf000;
	unsigned short timecount=0;
	unsigned char  time[2]={0,0};
	
	unsigned short sheetcount1=0;
	unsigned short sheetcount2=0;
	
	unsigned short lengthoffset1=0;
	unsigned short lengthoffset2=0;
	
	unsigned short pwm;
	
	unsigned char stop1=1;
	unsigned char stop2=1;
	unsigned char pause=0;
	
	unsigned char song=0;
	unsigned char dispindex=0;
	
	unsigned short* length;//=lengthx[0];
	unsigned short* sheet1;//=sheetx1[0];
	unsigned short* sheet2;//=sheetx2[0];
	unsigned short stopoffset;//=stopoffsetx[0];
	
	unsigned char repeatcount[4];
	unsigned short repeatjump[4];
	unsigned char repeatind;
	
	unsigned char symbol[16] ={
		SYMB_0,
		SYMB_1,
		SYMB_2,
		SYMB_3,
		SYMB_4,
		SYMB_5,
		SYMB_6,
		SYMB_7,
		SYMB_8,
		SYMB_9,
		SYMB_A,
		SYMB_B,
		SYMB_C,
		SYMB_D,
		SYMB_E,
		SYMB_F};
	
	unsigned char help = 0;
	
	__interrupt void P2_ISR();
	__interrupt void WD_ISR();
	void display(
		unsigned char *data);
	void spi(
		unsigned char command,
		unsigned char addr,
		unsigned char *inbuf,
		unsigned char *outbuf,
		unsigned short n);
	int main( void );

	void display(unsigned char *data)
	{
		//lsd
		P1OUT =data[0];
		P3OUT |=0x80; //74hc373 latch enable
		P3OUT &=0x0f;
		
		P1OUT =data[1];
		P3OUT |=0x40;
		P3OUT &=0x0f;
		
		P1OUT =data[2];
		P3OUT |=0x20;
		P3OUT &=0x0f;
		
		//msd
		P1OUT =data[3];
		P3OUT |=0x10;
		P3OUT &=0x0f;
	}

	void spi(
		unsigned char command,
		unsigned char addr,
		unsigned char *inbuf,
		unsigned char *outbuf,
		unsigned short n)
	{
		unsigned short i;
		unsigned char nul;
		unsigned char flags;
		
		switch (command)
		{
		case RTC_EEREAD:
		case RTC_IDREAD:
		case RTC_READ:
			flags= ADDRFLAG|READFLAG;
			break;
			
		case RTC_EEWRITE:
		case RTC_IDWRITE:
			n=(n>8)?8:n;
		case RTC_WRITE:
			flags= ADDRFLAG|WRITEFLAG;
			break;
			
		case RTC_EEWREN:
		case RTC_EEWRDI:
			flags=0;
			break;
			
		case RTC_SRREAD:
			n=(n>1)?1:n;
			flags=READFLAG;
			break;
		
		case RTC_SRWRITE: //1
		case RTC_CLRRAM: //data ignored but has to be
		case RTC_UNLOCK: //1
			 n=(n>1)?1:n;
			flags=WRITEFLAG;
			break;
		default:
			return;
		}
		
		P3OUT&=0xfe; //chip select down
		 
		#if !(defined DEBAG)
		while((IFG2&UTXIFG0)==0); // wait until can be sent
		#endif
		U0TXBUF=command; // send command
		#if !(defined DEBAG)
		while((IFG2&UTXIFG0)==0); // wait until received
		#endif
		nul=U0RXBUF; //pretend to read "data"
		
		if(flags&ADDRFLAG)
		{
			#if !(defined DEBAG)
			while((IFG2&UTXIFG0)==0); // wait until can be sent
			#endif
			U0TXBUF=addr; // send address
			#if !(defined DEBAG)
			while((IFG2&UTXIFG0)==0); // wait until received
			#endif
			nul=U0RXBUF; //pretend to read "data"
		}
		if(flags&(READFLAG|WRITEFLAG))
		{
			for(i=0;i<n;++i)
			{
				#if !(defined DEBAG)
				while((IFG2&UTXIFG0)==0); // wait until can be sent
				#endif
				U0TXBUF=(flags&WRITEFLAG)?outbuf[i]:0xff; // send data
				#if !(defined DEBAG)
				while((IFG2&UTXIFG0)==0); // wait until received
				#endif
				if(flags&READFLAG)
					inbuf[i]=U0RXBUF; //read data
				else
					nul=U0RXBUF;
			}
		}
		P3OUT|=0x01; //chip select up
		for(i=0;i<255;++i); //looks like the RTC might not like another SPI transmission exactly before the previous one, sometimes.
	}
	
	#pragma vector=WDT_VECTOR
	__interrupt void WD_ISR()
	{
		TACCTL0=pwm;
		++wavecount1;
		++wavecount2;
		if(wavecount1>wavestop1)
		{
			wavecount1=0;
			channel^=0x01;
		}
		if(wavecount2>wavestop2)
		{
			wavecount2=0;
			channel^=0x02;
		}
		active&=select;
		channel&=active;
		if (pause)
			channel=0;
		if(channel==0x00)
			pwm=CM_0|OUTMOD_5;
		else if(channel==0x03)
			pwm=CM_0|OUTMOD_1;
		else
			pwm=CM_0|OUTMOD_4;
		
	}
	
	#pragma vector=PORT2_VECTOR
	__interrupt void P2_ISR()
	{

		if(P2IFG&0x02) // button A - start
		{
			P2IFG &= ~0x02;
			
			stop1=0;
			stop2=0;
			pause=0;
			active=0;
			noteend1=0;
			noteend2=0;
			notestop1=0;
			notestop2=0;
			notecount1=0xf000;
			notecount2=0xf000;
			timecount=0;
			time[0]=0;
			time[1]=0;
			sheetcount1=0;
			sheetcount2=0;
			lengthoffset1=0;
			lengthoffset2=0;
			repeatjump[0]=0;
			repeatjump[1]=0;
			repeatjump[2]=0;
			repeatjump[3]=0;
			repeatcount[0]=0;
			repeatcount[1]=0;
			repeatcount[2]=0;
			repeatcount[3]=0;
		}
		else if(P2IFG&0x01) // button B - pause (or next song)
		{
			P2IFG &= ~0x01;
			
			if(stop1 && stop2)
			{
				if(!dispindex)
					dispindex = 1;
				else
				{
					++song;
					// song %= NO_OF_SONGS;
					if ((song == NO_OF_SONGS) && (P2IN&0x20)) // pressed C allows to skip index reset.
						song = 0;
					length=lengthx[song%NO_OF_SONGS]; 
					sheet1=sheetx1[song];
					sheet2=sheetx2[song];
					stopoffset=stopoffsetx[song];
				}
			}
			else
				pause = !pause;
		}
		else if(P2IFG&0x20) // button C - stop (or toggle channels)
		{
			P2IFG &= ~0x20;
			
			if(stop1 && stop2)
			{
				if(dispindex)
					dispindex=0;
				else
				{
					select-=0x01;
					select&=0x03;
				}
			}
			else
			{
				stop1=1;
				stop2=1;
				active = 0;
			}
		}
		else if(P2IFG&0x08) // RTC
		{
			P2IFG &= ~0x08;
			
			if(!pause)
			{
				++notecount1;
				++notecount2;
				++timecount;
			}
			if(notecount1>=notestop1)
			{
				active &= ~0x01;
				notestop1=0xffff;
			}
			
			if(notecount1>=noteend1 && !stop1)
			{
				notecount1=0;
				while(sheet1[sheetcount1]>= NXSP)
				{
					switch(sheet1[sheetcount1]& LENG)
					{
					case RPST:
						repeatind=(sheet1[sheetcount1]&0x03ff)>>8;
						repeatcount[repeatind]=sheet1[sheetcount1]&0x00ff;
						++sheetcount1;
						repeatjump[repeatind]=sheetcount1;
						break;
					case RPND:
						repeatind=(sheet1[sheetcount1]&0x03ff)>>8;
						if(repeatcount[repeatind]) {
							if(sheet1[sheetcount1] & SNGL)
								--(repeatcount[repeatind]);
							sheetcount1=repeatjump[repeatind];
						}
						else
							++sheetcount1;
						break;
					case NXSP:
						lengthoffset1+=10;
						++sheetcount1;
						break;
					case STOP:
						stop1=1;
					case REPL:
						// repeatjump[0]=0;
						// repeatjump[1]=0;
						// repeatjump[2]=0;
						// repeatjump[3]=0;
						// repeatcount[0]=0;
						// repeatcount[1]=0;
						// repeatcount[2]=0;
						// repeatcount[3]=0;
						timecount=0;
						time[0]=0;
						time[1]=0;
						lengthoffset1=0;
						sheetcount1 = 0;
						noteend1 = 0;
						active &= ~0x01;
						break;
					default:
						++sheetcount1;
					}
				}
				if(!stop1)
				{
					noteend1=length[((sheet1[sheetcount1] & LENG)>>12)+lengthoffset1];
					if (sheet1[sheetcount1] & PTCH)
					{
						wavestop1=sheet1[sheetcount1] & PTCH;
						if(wavestop1==wavestop2)
						{
							wavecount1=wavecount2 + (wavestop2>>1);
							if(wavecount1 > wavestop2)
								wavecount1-=wavestop2;
							// channel=(channel&0x02)?0x03:0x00;
						}
						active |= 0x01;
						if (sheet1[sheetcount1] & SNGL)
							notestop1=noteend1-stopoffset;
						else
							notestop1=0xffff;
					}
					else
					{
						active &= ~0x01;
						notestop1=0xffff;
					}
					++sheetcount1;
				}
			}
			
			if(notecount2>=notestop2)
			{
				active &= ~0x02;
				notestop2=0xffff;
			}
			
			if(notecount2>=noteend2 && !stop2)
			{
				notecount2=0;
				while(sheet2[sheetcount2]>= NXSP)
				{
					switch(sheet2[sheetcount2]& LENG)
					{
					case RPST:
						repeatind=(sheet2[sheetcount2]&0x03ff)>>8;
						repeatcount[repeatind]=sheet2[sheetcount2]&0x00ff;
						++sheetcount2;
						repeatjump[repeatind]=sheetcount2;
						break;
					case RPND:
						repeatind=(sheet2[sheetcount2]&0x03ff)>>8;
						if(repeatcount[repeatind]) {
							if(sheet2[sheetcount2] & SNGL)
								--(repeatcount[repeatind]);
							sheetcount2=repeatjump[repeatind];
						}
						else
							++sheetcount2;
						break;
					case NXSP:
						lengthoffset2+=10;
						++sheetcount2;
						break;
					case STOP:
						stop2=1;
					case REPL:
						// repeatjump[0]=0;
						// repeatjump[1]=0;
						// repeatjump[2]=0;
						// repeatjump[3]=0;
						// repeatcount[0]=0;
						// repeatcount[1]=0;
						// repeatcount[2]=0;
						// repeatcount[3]=0;
						timecount=0;
						time[0]=0;
						time[1]=0;
						lengthoffset2=0;
						sheetcount2 = 0;
						noteend2 = 0;
						active &= ~0x02;
						break;
					default:
						++sheetcount2;
					}
				}
				if(!stop2)
				{
					noteend2=length[((sheet2[sheetcount2] & LENG)>>12)+lengthoffset2];
					if (sheet2[sheetcount2] & PTCH)
					{
						wavestop2=sheet2[sheetcount2] & PTCH;
						if(wavestop2==wavestop1)
						{
							wavecount2=wavecount1 + (wavestop1>>1);
							if(wavecount2 > wavestop1)
								wavecount2-=wavestop1;
							// channel=(channel&0x01)?0x03:0x00;
						}
						active |= 0x02;
						if (sheet2[sheetcount2] & SNGL)
							notestop2=noteend2-stopoffset;
						else
							notestop2=0xffff;
					}
					else
					{
						active &= ~0x02;
						notestop2=0xffff;
					}
					++sheetcount2;
				}
			}
			
			if(timecount>=4096)
			{
				timecount=0;
				if(time[0]>=0x59)
				{
					time[0]=0x00;
					time[1]=bcd_add_byte(time[1],0x01);
				}
				else
					time[0]=bcd_add_byte(time[0],0x01);
			}
		}
		else
			P2IFG=0;
		return;
	}

	int main( void )
	{
		//watchdog stop
		WDTCTL = WDTPW + WDTHOLD;
		
		//init 7 segment display
		
		P1OUT =0xff; //display data on p1
		P1DIR =0xff;
		
		P3OUT &=0x0f; //display control on p3.4-7
		P3DIR |=0xf0; 
		
		outbuf[0]=SYMB_NUL;
		outbuf[1]=SYMB_o;
		outbuf[2]=SYMB_o;
		outbuf[3]=SYMB_NUL;
		
		display(outbuf);  
		
		//clocking:
		
		BCSCTL2 |= DIVM_3; //errata sheet recommends this here 
		
		DCOCTL =0x00;
		BCSCTL1 =
			RSEL2| //in the
			XTS| //hi freq
			DIVA_1; //ACLK = 6/2 MHz
		
		#if !(defined DEBAG)
		do
		{
			IFG1 &= ~OFIFG;
			for (outbuf[0] = 0xFF; outbuf[0] > 0; --(outbuf[0]));
		}
		while ((IFG1 & OFIFG)); 
		#endif
		
		BCSCTL2 =
			SELM_2| //MCLK from XT2
			DIVM_0| //MCLK = 6/1 MHz
			SELS| //SMCLK from XT2
			DIVS_0; //SMCLK = 6/1 MHz
			
		//init SPI
		
		P3SEL =0x0e; // SPI on p3.1, 3.2, 3.3
		P3OUT |=0x01;
		P3DIR |=0x01; //RTC CS on p3.0
		
		U0CTL =
			SWRST| //reset
			MM| //master
			SYNC| //SPI mode
			CHAR; //8 bit data
		U0TCTL=
			CKPH| //polarity and phase
			SSEL0|SSEL1| //SMCLK
			STC; //3 pin mode
		U0BR1=0x00;
		U0BR0=0x02; //baudrate = SMCLK/2 = 3MHz
		U0MCTL=0x00;
		ME2|=USPIE0;
		U0CTL &= ~SWRST;
		
		
		//init RTC
		
		//Looks like sometimes the first SPI reads rom the RTC may be incorrect.
		//To be sure, let's do a few redundant reads before starting the real work
		
		#if !(defined DEBAG)
		for (outbuf[0] = 0xFF; outbuf[0] > 0; --(outbuf[0]))
			 spi(RTC_READ,0x00,inbuf,outbuf,1);
		#endif
		
		//set control register
		//spi(RTC_READ,0x08,inbuf,outbuf,1);
		outbuf[0]=
			0x40| //squarewave enable
			0x01; //4096Hz
		spi(RTC_WRITE,0x08,inbuf,outbuf,1);
		
		//start oscillator
		spi(RTC_READ,0x01,inbuf,outbuf,1);
		if(!(inbuf[0]&0x80))
		{
			outbuf[0]=inbuf[0]|0x80;
			spi(RTC_WRITE,0x01,inbuf,outbuf,1);
		}
		
		
		//init timer for 3-level PWM:
		TACCR0 = 1; //full freq.
		TACCTL0=
			CM_0| //no capture
			OUTMOD_4; //toggle mode, PWM levels: 0-reset, 0.5-toggle, 1-set
		TACTL=
			TASSEL_2| //SMCLK, 6MHz
			ID_0| //6MHz/1
			MC_1| //up mode
			TACLR; //reset
		P2SEL|=0x04; //P2.2 timer output.
		P2DIR|=0x04;
		
		// Init WD timer
		WDTCTL=
			WDTPW|
			WDTTMSEL|
			WDTSSEL|
			WDTIS1|
			WDTIS0;
		
		IE1|=WDTIE;
		
		// Init interrupts
		P2IE=
			0x08| //p2.3 - int. from RTC
			0x02| //p2.1 - int. from button A
			0x01| //p2.0 - int. from button B
			0x20; //p2.5 - int. from button C
		P2IES|=0x01|0x02|0x20; //button int. on falling edge
		P2IES&= ~0x08; //RTC int. on rising edge
		P2IFG=0x00;
		
		length = lengthx[0];
		sheet1 = sheetx1[0];
		sheet2 = sheetx2[0];
		stopoffset = stopoffsetx[0];
		
		__enable_interrupt();
		
		
		while(1)
		{
			if(stop1 && stop2)
			{
				if(dispindex)
				{
					outbuf[0]=symbol[song];
					outbuf[1]=SYMB_NUL;
					outbuf[2]=SYMB_NUL;
					outbuf[3]=SYMB_NUL;
				}
				else
				{
					outbuf[0]=SYMB_NUL;
					outbuf[1]=(select&0x02)?SYMB_o:SYMB_MIN;
					outbuf[2]=(select&0x01)?SYMB_o:SYMB_MIN;
					outbuf[3]=SYMB_NUL;
				}
			}
			// else if(pause)
			// {
				// outbuf[0]=SYMB_NUL;
				// outbuf[1]=SEG_F;
				// outbuf[2]=SEG_B;
				// outbuf[3]=SYMB_NUL;
			// }
			else
			{
				outbuf[0]= symbol[ time[0]&0x0f    ] & ((active&0x01)?SYMB_DOT:SYMB_NUL);
				outbuf[1]= symbol[(time[0]&0xf0)>>4] & ((active&0x02)?SYMB_DOT:SYMB_NUL);
				outbuf[2]= symbol[ time[1]&0x0f    ]; 
				// outbuf[3]=(symbol[(time[1]&0xf0)>>4] | ((time[1]&0xf0)?SYMB_8:SYMB_NUL)) & (pause ? SYMB_NUL : SYMB_DOT);
				outbuf[3]=(symbol[(time[1]&0xf0)>>4] | ((time[1]&0xf0)?SYMB_8:SYMB_NUL)) & (((wavestop1==wavestop2) && ((active&0x03)==0x03)) ? SYMB_DOT : SYMB_NUL);
			}
			display(outbuf);  
			
		}
	}
